﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;
using System.Data;

namespace MS_OSPFM
{
    public partial class AttribSearch : System.Web.UI.Page
    {
        string colName = string.Empty;
        string colValue = string.Empty;

        string strSQL = string.Empty;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                #region Set Map Properties and values
                string sUnit = "Meter";
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapTools.PanZoom.Enabled = false;
                Map1.MapTools.PanZoomBar.Enabled = true;
                Map1.MapUnit = (GeographyUnit)Enum.Parse(typeof(GeographyUnit), sUnit);

                LayerOverlay layerOverLay = new LayerOverlay("OSPFM Layers");
                layerOverLay.IsBaseOverlay = false;
                layerOverLay.ClientCache.CacheId = "OSPFM_Layers";
                layerOverLay.TransitionEffect = TransitionEffect.None;
                layerOverLay.TileType = TileType.SingleTile;
                layerOverLay.Layers.Clear();

                //# end of Map properties
                #endregion

                //15 - Load Access_Point
                ShapeFileFeatureLayer lyr_points_Access_Point = new ShapeFileFeatureLayer(Server.MapPath("~/Data/Access_Points.shp"));
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Square, GeoColor.SimpleColors.Blue, 15f);
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.DefaultTextStyle = TextStyles.City1("TYPE_NAME");
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_points_Access_Point.DrawingMarginPercentage = 50;

                lyr_points_Access_Point.Close();

                //3 - Load Buried_Cable
                ShapeFileFeatureLayer lyr_lines_Buried_Cable = new ShapeFileFeatureLayer(Server.MapPath("~/Data/Buried_Cable.shp"));
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel15.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Blue, 1f, true);
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel15.DefaultTextStyle = TextStyles.Pipeline1("LABEL");
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel15.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_lines_Buried_Cable.DrawingMarginPercentage = 50;

                Proj4Projection proj4_points_Access_Points = new Proj4Projection();
                proj4_points_Access_Points.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_points_Access_Points.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_points_Access_Point.FeatureSource.Projection = proj4_points_Access_Points;

                Proj4Projection proj4_lines_Buried_Cable = new Proj4Projection();
                proj4_lines_Buried_Cable.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_lines_Buried_Cable.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_lines_Buried_Cable.FeatureSource.Projection = proj4_lines_Buried_Cable;
                

                layerOverLay.Layers.Add("Lyr_Access_Point", lyr_points_Access_Point);
                layerOverLay.Layers.Add("Lyr_Buried_Cable", lyr_lines_Buried_Cable);

                
                VirtualEarthOverlay ve = new VirtualEarthOverlay("VirtualEarth Map");
                ve.VirtualEarthMapType = VirtualEarthMapType.Birdseye;

                Map1.CustomOverlays.Clear();
                Map1.CustomOverlays.Add(layerOverLay);
                Map1.CustomOverlays.Add(ve);
            }
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            colName = "OBJECTID";
            colValue = "124349";
            ListBox1.Items.Clear();

            ShapeFileFeatureLayer lyr_points_Access_Point = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["Lyr_Access_Point"];

            strSQL = "Select OBJECTID,TYPE_NAME,OWNER,LABEL,PROJ_NUM,MUX_CODE,PROJ_NAME from Access_Points Where " + colName + " = " + colValue;
 
            lyr_points_Access_Point.Open();
            DataTable dt = lyr_points_Access_Point.QueryTools.ExecuteQuery(strSQL);

            GridView1.DataSource = dt;
            GridView1.DataBind();

            System.Collections.ObjectModel.Collection<Feature> features = lyr_points_Access_Point.FeatureSource.GetFeaturesByColumnValue(colName, colValue);

            lyr_points_Access_Point.Close();

            if (features.Count > 0)
            {
                ListItem li; 
                for (int i = 0; i < features.Count; i++)
                {
                    li = new ListItem(colValue, features[i].GetWellKnownText());
                    ListBox1.Items.Add(li);
                }
            }
        }

        protected void ListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
                if (ListBox1.SelectedItem.Value.Contains("POINT") == true || ListBox1.SelectedItem.Value.Contains("MULTILINESTRING") == true)
                {
                    RectangleShape rs = new RectangleShape(ListBox1.SelectedItem.Value);
                    Map1.CurrentExtent = ExtentHelper.GetDrawingExtent(rs, (float)Map1.WidthInPixels, (float)Map1.HeightInPixels);
                }
            }

        protected void Button2_Click(object sender, EventArgs e)
        {
            //colName = "LABEL";
            //colValue = "MCI - 44 F";
            //colName = "OBJECTID";
            //colValue = "236567";
            colName = "OBJECTID";
            colValue = "236567";

            ListBox1.Items.Clear();

            ShapeFileFeatureLayer lyr_lines_Buried_Cable = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["Lyr_Buried_Cable"];

            //strSQL = "Select OBJECTID,TYPE_NAME,STATUS,LENGTH,LABEL,PROJ_NUM,ALIAS,PRL_NUM,PROJ_NAME from Buried_Cable Where " + colName + " = " + colValue;
            strSQL = "Select OBJECTID,TYPE_NAME,STATUS,LENGTH,LABEL,PROJ_NUM,ALIAS,PRL_NUM,PROJ_NAME from Buried_Cable Where TYPE_NAME ='DBURIED' and STATUS ='ABD'";

            lyr_lines_Buried_Cable.Open();
            DataTable dt = lyr_lines_Buried_Cable.QueryTools.ExecuteQuery(strSQL);

            GridView1.DataSource = dt;
            GridView1.DataBind();

            for (int j = 0; j < dt.Rows.Count; j++)
            {
                System.Collections.ObjectModel.Collection<Feature> features = lyr_lines_Buried_Cable.FeatureSource.GetFeaturesByColumnValue("OBJECTID", dt.Rows[j]["OBJECTID"].ToString());

                if (features.Count > 0)
                {
                    ListItem li;
                    for (int i = 0; i < features.Count; i++)
                    {
                        li = new ListItem(dt.Rows[0]["OBJECTID"].ToString(), features[i].GetWellKnownText());
                        ListBox1.Items.Add(li);
                    }
                }
            }

            lyr_lines_Buried_Cable.Close();
        }
   }
}
